import java.awt.*;
import java.io.*;
import java.net.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;
import java.applet.*;
public class Kmoon3D2Applet extends JApplet implements Runnable,ActionListener,KeyListener{
    JLabel la;
    Vector<String> lcontent;
    JList<String> l;
    JScrollPane spl;
    JButton start;
    JPanel p;
    Thread t;
    boolean startb=false;
    boolean running=true;
    GameKmoon3D2 game;
    KeyboardMapperAppletSwing km=null;
    static Kmoon3D2Applet app;
    private static final long serialVersionUID = -1979696437774536074L;
    public void init(){
//        super("Astro Solutions Kmoon3D2");
//        pack();
        app=this;
        setSize(800,480);
        setLayout(null);
        la=new JLabel("player 1: cursor keys, return player 2: s y x c a quit level: ESC");
        lcontent=new Vector<String>();
        l=new JList<String>(lcontent);
        spl=new JScrollPane(l);
        start=new JButton("start");
        p=new JPanel();
        p.setLayout(null);
        add(la);
        p.add(spl);
        p.add(start);
        la.setBounds(10,40,380,27);
        spl.setBounds(10,40,380,250);
        start.setBounds(10,300,380,27);
        add(p);
        p.setBounds(0,40,400,400);
        setVisible(true);
        p.setVisible(true);
        start.addActionListener(this);
        addKeyListener(this);
        requestFocus();
        t=new Thread(this);
        t.start();
    }
    public void run(){
        p.setVisible(false);
        km=new KeyboardMapperAppletSwing(this);
        add(km);
        km.setBounds(0,70,400,400);
        km.setVisible(true);
        while(!km.closed){
            try{
                Thread.sleep(100);
            }
            catch(Exception e){
            }
        }
        p.setVisible(true);
        requestFocus();
        loadlevs();
        while(running){
            if(startb){
                startb=false;
                int ind=l.getSelectedIndex();
                if(ind!=-1&&ind<lcontent.size()){
                    String s=lcontent.elementAt(ind);
                    game=new GameKmoon3D2(this,s);
                    p.setVisible(false);
                    add(game);
                    game.setBounds(0,80,800,400);
                    requestFocus();
                }
            }
            try{
                Thread.sleep(100);
            }
            catch(Exception e){
            }
        }
    }
    public static InputStream getInputStream(String filename){
        try{
            InputStream is=app.getClass().getResourceAsStream("/"+filename);
//            FileInputStream fis=new FileInputStream(filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public void loadlevs(){
        try{
            InputStream is=Kmoon3D2Applet.getInputStream("levs.ini");
            BufferedReader dis=new BufferedReader(new InputStreamReader(is));
            String news="";
            while((news=dis.readLine())!=null){
                lcontent.addElement(news);
            }
            is.close();
            l.setListData(lcontent);
        }
        catch(Exception e){};
    }
    public void actionPerformed(ActionEvent evt){
        if(evt.getSource()==start){
            startb=true;
        }
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        int key=e.getKeyCode();
        if(km!=null&&km.applyb){
            key=km.getKeyCode(key);
        }
//System.out.println("key: "+key);
        if(game!=null&&key>0){
            game.process(key);
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public static void main(String[]args){
        new Kmoon3D2Applet();
    }
}
class GameKmoon3D2 extends JPanel implements Runnable{
    Kmoon3D2Applet kmoon3d2;
    EngineKmoon3D2 eng;
    EngineKmoon3D2 eng2;
    Thread t;
    String level="";
    int[][]screen=new int[30][18];
    Group[][]bgroups=new Group[32][20];
    Group[][]groups=new Group[32][20];
    Group[][]bgroups2=new Group[32][20];
    Group[][]groups2=new Group[32][20];
    Kugel kug;
    Kugel moon;
    Kugel kugb;
    Kugel moonb;
    Kugel kug2;
    Kugel moon2;
    Kugel kugb2;
    Kugel moonb2;
    int xstart;
    int ystart;
    double xpos;
    double ypos;
    double xdrift=0;
    double ydrift=0;
    double xpos2;
    double ypos2;
    double xdrift2=0;
    double ydrift2=0;
    double malpha=0;
    boolean mreverse=false;
    double malpha2=0;
    boolean mreverse2=false;
    boolean running=true;
    double alpha=Math.PI/2;
    double beta=Math.PI/4;
    double alpha2=Math.PI/2;
    double beta2=Math.PI/4;
    int fahnen=0;
    int robos=0;
    int lifes=3;
    int lifes2=3;
    int mode=1;
    int mode2=1;
    int ax=800;
    int ay=400;
    boolean lost=false;
    boolean completed=false;
    int keycode=0;
    private static final long serialVersionUID = -7275362645882463967L;
    public GameKmoon3D2(Kmoon3D2Applet kmoon3d2,String level){
//        super("Astro Solutions Kmoon3D2");
//        pack();
        setSize(800,400);
        setLayout(null);
        this.kmoon3d2=kmoon3d2;
        this.level=level;
        eng=new EngineKmoon3D2();
        add(eng);
        eng.setBounds(0,0,400,400);
        eng2=new EngineKmoon3D2();
        add(eng2);
        eng2.setBounds(400,0,400,400);
        eng.setStatus("");
        eng2.setStatus("");
        setVisible(true);
        t=new Thread(this);
        t.start();
    }
    public void left(){
        if(mode==0){
            alpha=alpha+Math.PI/90;
        }
        else{
            xdrift=xdrift-1;
        }
    }
    public void right(){
        if(mode==0){
            alpha=alpha-Math.PI/90;
        }
        else{
            xdrift=xdrift+1;
        }
    }
    public void up(){
        if(mode==0){
            beta=beta+Math.PI/90;
            if(beta>Math.PI/2){
                beta=Math.PI/2;
            }
        }
        else{
            ydrift=ydrift+1;
        }
    }
    public void down(){
        if(mode==0){
            beta=beta-Math.PI/90;
            if(beta<-Math.PI/2){
                beta=-Math.PI/2;
            }
        }
        else{
            ydrift=ydrift-1;
        }
    }
    public void left2(){
        if(mode2==0){
            alpha2=alpha2+Math.PI/90;
        }
        else{
            xdrift2=xdrift2-1;
        }
    }
    public void right2(){
        if(mode2==0){
            alpha2=alpha2-Math.PI/90;
        }
        else{
            xdrift2=xdrift2+1;
        }
    }
    public void up2(){
        if(mode2==0){
            beta2=beta2+Math.PI/90;
            if(beta2>Math.PI/2){
                beta2=Math.PI/2;
            }
        }
        else{
            ydrift2=ydrift2+1;
        }
    }
    public void down2(){
        if(mode2==0){
            beta2=beta2-Math.PI/90;
            if(beta2<-Math.PI/2){
                beta2=-Math.PI/2;
            }
        }
        else{
            ydrift2=ydrift2-1;
        }
    }
    public void process(int key){
        keycode=key;
    }
    public void process2(int key){
            if(key==KeyEvent.VK_ESCAPE||key==27){
                running=false;
                setVisible(false);
                kmoon3d2.remove(this);
                kmoon3d2.p.setVisible(true);
            }
            if(key==KeyEvent.VK_LEFT){
                left();
            }
            if(key==KeyEvent.VK_RIGHT){
                right();
            }
            if(key==KeyEvent.VK_DOWN){
                up();
            }
            if(key==KeyEvent.VK_UP){
                down();
            }
            if(key==KeyEvent.VK_ENTER||key==10||key==13){
                if(mode==0){
                    mode=1;
                }
                else{
                    mode=0;
                }
            }
            if(key==89){
                left2();
            }
            if(key==67){
                right2();
            }
            if(key==88){
                up2();
            }
            if(key==83){
                down2();
            }
            if(key==65){
                if(mode2==0){
                    mode2=1;
                }
                else{
                    mode2=0;
                }
            }
    }
    public void run(){
        try{
            InputStream fis=Kmoon3D2Applet.getInputStream(level);
            for(int i=0;i<30;i++){
                for(int j=0;j<18;j++){
                    screen[i][j]=fis.read();
                }
            }
            fis.close();
        }
        catch(Exception e){
System.out.println("e: "+e+" lev: "+level);
        }
        for(int i=0;i<32;i++){
            for(int j=0;j<20;j++){
                bgroups[i][j]=ObjectGenerator.getBoden();
                bgroups[i][j].transform(i*40,j*40,0);
                eng.add(bgroups[i][j]);
                bgroups2[i][j]=ObjectGenerator.getBoden();
                bgroups2[i][j].transform(i*40,j*40,0);
                eng2.add(bgroups2[i][j]);
            }
        }
        for(int i=0;i<32;i++){
            groups[i][0]=ObjectGenerator.getStone();
            eng.add(groups[i][0]);
            groups[i][0].transform(i*40,0,0);
            groups[i][19]=ObjectGenerator.getStone();
            groups[i][19].transform(i*40,19*40,0);
            eng.add(groups[i][19]);
            groups2[i][0]=ObjectGenerator.getStone();
            eng2.add(groups2[i][0]);
            groups2[i][0].transform(i*40,0,0);
            groups2[i][19]=ObjectGenerator.getStone();
            groups2[i][19].transform(i*40,19*40,0);
            eng2.add(groups2[i][19]);
        }
        for(int i=0;i<18;i++){
            groups[0][1+i]=ObjectGenerator.getStone();
            groups[0][1+i].transform(0,(1+i)*40,0);
            eng.add(groups[0][1+i]);
            groups[19][1+i]=ObjectGenerator.getStone();
            groups[19][1+i].transform(31*40,(1+i)*40,0);
            eng.add(groups[19][1+i]);
            groups2[0][1+i]=ObjectGenerator.getStone();
            groups2[0][1+i].transform(0,(1+i)*40,0);
            eng2.add(groups2[0][1+i]);
            groups2[19][1+i]=ObjectGenerator.getStone();
            groups2[19][1+i].transform(31*40,(1+i)*40,0);
            eng2.add(groups2[19][1+i]);
        }
        for(int i=0;i<30;i++){
            for(int j=0;j<18;j++){
//System.out.print(" "+screen[i][j]);
                if(screen[i][j]==1){
                    groups[1+i][1+j]=ObjectGenerator.getObject();
                    groups[1+i][1+j].transform((1+i)*40,(1+j)*40,0);
                    eng.add(groups[1+i][1+j]);
                    groups2[1+i][1+j]=ObjectGenerator.getObject();
                    groups2[1+i][1+j].transform((1+i)*40,(1+j)*40,0);
                    eng2.add(groups2[1+i][1+j]);
                    fahnen++;
                }
                else if(screen[i][j]==2){
                    groups[1+i][1+j]=ObjectGenerator.getRobo();
                    groups[1+i][1+j].transform((1+i)*40,(1+j)*40,0);
                    eng.add(groups[1+i][1+j]);
                    groups2[1+i][1+j]=ObjectGenerator.getRobo();
                    groups2[1+i][1+j].transform((1+i)*40,(1+j)*40,0);
                    eng2.add(groups2[1+i][1+j]);
                    robos++;
                }
                else if(screen[i][j]==4){
                    groups[1+i][1+j]=ObjectGenerator.getStone();
                    groups[1+i][1+j].transform((1+i)*40,(1+j)*40,0);
                    eng.add(groups[1+i][1+j]);
                    groups2[1+i][1+j]=ObjectGenerator.getStone();
                    groups2[1+i][1+j].transform((1+i)*40,(1+j)*40,0);
                    eng2.add(groups2[1+i][1+j]);
                }
                else if(screen[i][j]==5){
                    groups[1+i][1+j]=ObjectGenerator.getBlack();
                    groups[1+i][1+j].transform((1+i)*40,(1+j)*40,0);
                    eng.add(groups[1+i][1+j]);
                    groups2[1+i][1+j]=ObjectGenerator.getBlack();
                    groups2[1+i][1+j].transform((1+i)*40,(1+j)*40,0);
                    eng2.add(groups2[1+i][1+j]);
                }
                else if(screen[i][j]==3){
                    xstart=(1+i)*40+20;
                    ystart=(1+j)*40+20;
                    xpos=xstart;
                    ypos=ystart;
                    xpos2=xstart;
                    ypos2=ystart;
                    Vektor v=new Vektor(xpos,ypos,20);
                    kug=new Kugel(Color.blue,Color.blue,v,15);
                    Vektor vm=new Vektor(xpos+Math.sin(malpha)*40,ypos+Math.cos(malpha)*40,20);
                    moon=new Kugel(Color.red,Color.red,vm,7.5);
                    eng.add(kug);
                    eng.add(moon);
                    Vektor vb=new Vektor(xpos,ypos,20);
                    kugb=new Kugel(Color.blue,Color.blue,vb,15);
                    Vektor vmb=new Vektor(xpos+Math.sin(malpha)*40,ypos+Math.cos(malpha)*40,20);
                    moonb=new Kugel(Color.red,Color.red,vmb,7.5);
                    eng2.add(kugb);
                    eng2.add(moonb);

                    Vektor v2=new Vektor(xpos2,ypos2,20);
                    kug2=new Kugel(Color.blue,Color.blue,v2,15);
                    Vektor vm2=new Vektor(xpos2+Math.sin(malpha2)*40,ypos2+Math.cos(malpha2)*40,20);
                    moon2=new Kugel(Color.red,Color.red,vm2,7.5);
                    eng2.add(kug2);
                    eng2.add(moon2);
                    Vektor vb2=new Vektor(xpos2,ypos2,20);
                    kugb2=new Kugel(Color.blue,Color.blue,vb2,15);
                    Vektor vmb2=new Vektor(xpos2+Math.sin(malpha2)*40,ypos2+Math.cos(malpha2)*40,20);
                    moonb2=new Kugel(Color.red,Color.red,vmb2,7.5);
                    eng.add(kugb2);
                    eng.add(moonb2);
                }
            }
//System.out.println("");
        }
        Vektor camerapos=new Vektor(xpos,ypos,200);
        Vektor cameraposplus=new Vektor(0,0,0);
        Vektor camerapos2=new Vektor(xpos2,ypos2,200);
        Vektor cameraposplus2=new Vektor(0,0,0);
        while(running){
            int xw=800;
            int yw=400;
            Dimension d=kmoon3d2.getSize();
            xw=d.width;
            yw=d.height-80;
            if(xw!=ax||yw!=ay){
                ax=xw;
                ay=yw;
                eng.setBounds(0,0,ax/2,ay);
                eng2.setBounds(ax/2,0,ax/2,ay);
                setBounds(0,80,ax,ay);
            }
            if(keycode!=0){
                process2(keycode);
            }
            keycode=0;
            camerapos.x=xpos;
            camerapos.y=ypos;
            cameraposplus.x=Math.cos(alpha)*300;
            cameraposplus.y=Math.sin(alpha)*300;
            double xtrans=camerapos.x+cameraposplus.x;
            double ytrans=camerapos.y+cameraposplus.y;
            double ztrans=camerapos.z+cameraposplus.z;
            double alphab=alpha;
            double betab=beta;
            eng.transform(-xtrans,-ytrans,-ztrans);
            alphab=alphab+Math.PI;
            if(alphab>2*Math.PI){
                alphab=alphab-2*Math.PI;
            }
            eng.rotLeft(-alphab);
            eng.rotUp(betab);
            eng.setOn();
            eng.move();

            camerapos2.x=xpos2;
            camerapos2.y=ypos2;
            cameraposplus2.x=Math.cos(alpha2)*300;
            cameraposplus2.y=Math.sin(alpha2)*300;
            double xtrans2=camerapos2.x+cameraposplus2.x;
            double ytrans2=camerapos2.y+cameraposplus2.y;
            double ztrans2=camerapos2.z+cameraposplus2.z;
            double alphab2=alpha2;
            double betab2=beta2;
            eng2.transform(-xtrans2,-ytrans2,-ztrans2);
            alphab2=alphab2+Math.PI;
            if(alphab2>2*Math.PI){
                alphab2=alphab2-2*Math.PI;
            }
            eng2.rotLeft(-alphab2);
            eng2.rotUp(betab2);
            eng2.setOn();
            eng2.move();

            eng.repaint();
            eng2.repaint();

            try{
                Thread.sleep(100);
            }
            catch(Exception exc){
            }

//            eng.setOff();
            eng.rotUp(-betab);
            eng.rotLeft(alphab);
            eng.transform(xtrans,ytrans,ztrans);

            eng2.rotUp(-betab2);
            eng2.rotLeft(alphab2);
            eng2.transform(xtrans2,ytrans2,ztrans2);

            xpos=xpos+xdrift;
            ypos=ypos+ydrift;
            double mx=Math.sin(malpha)*40;
            double my=Math.cos(malpha)*40;
            if(mreverse){
                malpha=malpha-Math.PI/90;
                if(malpha<0){
                    malpha=malpha+Math.PI*2;
                }
            }
            else{
                malpha=malpha+Math.PI/90;
                if(malpha>Math.PI*2){
                    malpha=malpha-Math.PI*2;
                }
            }
            double mx2=Math.sin(malpha)*40-mx;
            double my2=Math.cos(malpha)*40-my;
            kug.transform(xdrift,ydrift,0);
            moon.transform(xdrift+mx2,ydrift+my2,0);
            kugb.transform(xdrift,ydrift,0);
            moonb.transform(xdrift+mx2,ydrift+my2,0);

            xpos2=xpos2+xdrift2;
            ypos2=ypos2+ydrift2;
            mx=Math.sin(malpha2)*40;
            my=Math.cos(malpha2)*40;
            if(mreverse2){
                malpha2=malpha2-Math.PI/90;
                if(malpha2<0){
                    malpha2=malpha2+Math.PI*2;
                }
            }
            else{
                malpha2=malpha2+Math.PI/90;
                if(malpha2>Math.PI*2){
                    malpha2=malpha2-Math.PI*2;
                }
            }
            mx2=Math.sin(malpha2)*40-mx;
            my2=Math.cos(malpha2)*40-my;
            kug2.transform(xdrift2,ydrift2,0);
            moon2.transform(xdrift2+mx2,ydrift2+my2,0);
            kugb2.transform(xdrift2,ydrift2,0);
            moonb2.transform(xdrift2+mx2,ydrift2+my2,0);

            int sx=(int)(xpos/40);
            int sy=(int)(ypos/40);
            if(sx==0||sx==31){
                xdrift=-xdrift;
            }
            if(sy==0||sy==19){
                ydrift=-ydrift;
            }
            if(!lost&&!completed&&sx>0&&sy>0&&sx<31&&sy<19){
                int val=screen[sx-1][sy-1];
                if(val==1){
                    eng.remove(groups[sx][sy]);
                    eng2.remove(groups2[sx][sy]);
                    fahnen--;
                    screen[sx-1][sy-1]=0;
                }
                else if(val==2||val==5){
                    lifes--;
                    kug.transform(xstart-xpos,ystart-ypos,0);
                    moon.transform(xstart-xpos,ystart-ypos,0);
                    kugb.transform(xstart-xpos,ystart-ypos,0);
                    moonb.transform(xstart-xpos,ystart-ypos,0);
                    xpos=xstart;
                    ypos=ystart;
                    xdrift=0;
                    ydrift=0;
                    mreverse=false;
                }
                else if(val==4){
                    ydrift=-ydrift;
                }
            }
            double mxb=Math.sin(malpha)*40;
            double myb=Math.cos(malpha)*40;
            int sx2=(int)((xpos+mxb)/40);
            int sy2=(int)((ypos+myb)/40);
            if(sy2==0||sy2==19){
                if(mreverse){
                    mreverse=false;
                }
                else{
                    mreverse=true;
                }
            }
            if(sx2==0||sx2==31){
                if(mreverse){
                    mreverse=false;
                }
                else{
                    mreverse=true;
                }
            }
            if(!lost&&!completed&&sx2>0&&sy2>0&&sx2<31&&sy2<19){
                int val=screen[sx2-1][sy2-1];
                if(val==2){
                    eng.remove(groups[sx2][sy2]);
                    eng2.remove(groups2[sx2][sy2]);
                    robos--;
                    screen[sx2-1][sy2-1]=0;
                }
                else if(val==1||val==5){
                    lifes--;
                    kug.transform(xstart-xpos,ystart-ypos,0);
                    moon.transform(xstart-xpos,ystart-ypos,0);
                    kugb.transform(xstart-xpos,ystart-ypos,0);
                    moonb.transform(xstart-xpos,ystart-ypos,0);
                    xpos=xstart;
                    ypos=ystart;
                    xdrift=0;
                    ydrift=0;
                    mreverse=false;
                }
                else if(val==4){
                    if(mreverse){
                        mreverse=false;
                    }
                    else{
                        mreverse=true;
                    }
                }
            }

            sx=(int)(xpos2/40);
            sy=(int)(ypos2/40);
            if(sx==0||sx==31){
                xdrift2=-xdrift2;
            }
            if(sy==0||sy==19){
                ydrift2=-ydrift2;
            }
            if(!lost&&!completed&&sx>0&&sy>0&&sx<31&&sy<19){
                int val2=screen[sx-1][sy-1];
                if(val2==1){
                    eng.remove(groups[sx][sy]);
                    eng2.remove(groups2[sx][sy]);
                    fahnen--;
                    screen[sx-1][sy-1]=0;
                }
                else if(val2==2||val2==5){
                    lifes2--;
                    kug2.transform(xstart-xpos2,ystart-ypos2,0);
                    moon2.transform(xstart-xpos2,ystart-ypos2,0);
                    kugb2.transform(xstart-xpos2,ystart-ypos2,0);
                    moonb2.transform(xstart-xpos2,ystart-ypos2,0);
                    xpos2=xstart;
                    ypos2=ystart;
                    xdrift2=0;
                    ydrift2=0;
                    mreverse2=false;
                }
                else if(val2==4){
                    ydrift2=-ydrift2;
                }
            }
            mxb=Math.sin(malpha2)*40;
            myb=Math.cos(malpha2)*40;
            sx2=(int)((xpos2+mxb)/40);
            sy2=(int)((ypos2+myb)/40);
            if(sy2==0||sy2==19){
                if(mreverse2){
                    mreverse2=false;
                }
                else{
                    mreverse2=true;
                }
            }
            if(sx2==0||sx2==31){
                if(mreverse2){
                    mreverse2=false;
                }
                else{
                    mreverse2=true;
                }
            }
            if(!lost&&!completed&&sx2>0&&sy2>0&&sx2<31&&sy2<19){
                int val3=screen[sx2-1][sy2-1];
                if(val3==2){
                    eng.remove(groups[sx2][sy2]);
                    eng2.remove(groups2[sx2][sy2]);
                    robos--;
                    screen[sx2-1][sy2-1]=0;
                }
                else if(val3==1||val3==5){
                    lifes2--;
                    kug2.transform(xstart-xpos2,ystart-ypos2,0);
                    moon2.transform(xstart-xpos2,ystart-ypos2,0);
                    kugb2.transform(xstart-xpos2,ystart-ypos2,0);
                    moonb2.transform(xstart-xpos2,ystart-ypos2,0);
                    xpos2=xstart;
                    ypos2=ystart;
                    xdrift2=0;
                    ydrift2=0;
                    mreverse2=false;
                }
                else if(val3==4){
                    if(mreverse2){
                        mreverse2=false;
                    }
                    else{
                        mreverse2=true;
                    }
                }
            }

            if(completed||(fahnen<=0&&robos<=0)){
                kmoon3d2.la.setText("You have won!");
                completed=true;
            }
            else{
                if(lifes<=0||lifes2<=0){
                    kmoon3d2.la.setText("You have lost! Lifes player 1: "+lifes+" player 2: "+lifes2);
                    lost=true;
                }
                else{
                    kmoon3d2.la.setText("Objects: "+fahnen+" Robos: "+robos+" Lifes player 1: "+lifes+" player 2: "+lifes2);
                }
            }
        }
    }
}
class ObjectGenerator{
    public static Group getBoden(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(40,0,0);
        Vektor v3=new Vektor(40,40,0);
        Vektor v4=new Vektor(0,40,0);
        Quad q1=new Quad(Color.gray,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,0);
        Vektor v6=new Vektor(35,5,0);
        Vektor v7=new Vektor(35,35,0);
        Vektor v8=new Vektor(5,35,0);
        Quad q2=new Quad(Color.darkGray,Color.black,v5,v6,v7,v8);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        return g;
    }
    public static Group getBlack(){
        Vektor v1=new Vektor(0,0,1);
        Vektor v2=new Vektor(40,0,1);
        Vektor v3=new Vektor(40,40,1);
        Vektor v4=new Vektor(0,40,1);
        Quad q1=new Quad(Color.black,Color.black,v1,v2,v3,v4);
        Group g=new Group();
        g.add(q1);
        return g;
    }
    public static Group getStone(){
        Vektor v1=new Vektor(5,5,0);
        Vektor v2=new Vektor(35,5,0);
        Vektor v3=new Vektor(35,35,0);
        Vektor v4=new Vektor(5,35,0);
        Quad q1=new Quad(Color.yellow,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,30);
        Vektor v6=new Vektor(35,5,30);
        Vektor v7=new Vektor(35,35,30);
        Vektor v8=new Vektor(5,35,30);
        Quad q2=new Quad(Color.yellow,Color.black,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,30);
        Vektor v10=new Vektor(35,5,30);
        Vektor v11=new Vektor(35,5,0);
        Vektor v12=new Vektor(5,5,0);
        Quad q3=new Quad(Color.yellow,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,35,30);
        Vektor v14=new Vektor(35,35,30);
        Vektor v15=new Vektor(35,35,0);
        Vektor v16=new Vektor(5,35,0);
        Quad q4=new Quad(Color.yellow,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,5,30);
        Vektor v18=new Vektor(5,35,30);
        Vektor v19=new Vektor(5,35,0);
        Vektor v20=new Vektor(5,5,0);
        Quad q5=new Quad(Color.yellow,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(35,5,30);
        Vektor v22=new Vektor(35,35,30);
        Vektor v23=new Vektor(35,35,0);
        Vektor v24=new Vektor(35,5,0);
        Quad q6=new Quad(Color.yellow,Color.black,v21,v22,v23,v24);
        Vektor v25=new Vektor(10,10,30);
        Vektor v26=new Vektor(30,10,30);
        Vektor v27=new Vektor(30,30,30);
        Vektor v28=new Vektor(10,30,30);
        Quad q7=new Quad(Color.orange,Color.black,v25,v26,v27,v28);
        PaintGroup pg=new PaintGroup();
        q2.setPaintGroup(pg);
        q7.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        g.add(q7);
        return g;
    }
    public static Group getObject(){
        Vektor v1=new Vektor(5,5,0);
        Vektor v2=new Vektor(35,5,0);
        Vektor v3=new Vektor(35,35,0);
        Vektor v4=new Vektor(5,35,0);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,40);
        Vektor v6=new Vektor(35,5,40);
        Vektor v7=new Vektor(35,35,40);
        Vektor v8=new Vektor(5,35,40);
        Quad q2=new Quad(Color.orange,Color.black,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,40);
        Vektor v10=new Vektor(35,5,40);
        Vektor v11=new Vektor(35,5,0);
        Vektor v12=new Vektor(5,5,0);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,35,40);
        Vektor v14=new Vektor(35,35,40);
        Vektor v15=new Vektor(35,35,0);
        Vektor v16=new Vektor(5,35,0);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,5,40);
        Vektor v18=new Vektor(5,35,40);
        Vektor v19=new Vektor(5,35,0);
        Vektor v20=new Vektor(5,5,0);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(35,5,40);
        Vektor v22=new Vektor(35,35,40);
        Vektor v23=new Vektor(35,35,0);
        Vektor v24=new Vektor(35,5,0);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        Vektor v25=new Vektor(10,10,40);
        Vektor v26=new Vektor(30,10,40);
        Vektor v27=new Vektor(30,30,40);
        Vektor v28=new Vektor(10,30,40);
        Quad q7=new Quad(Color.blue,Color.black,v25,v26,v27,v28);
        PaintGroup pg=new PaintGroup();
        q2.setPaintGroup(pg);
        q7.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        g.add(q7);
        return g;
    }
    public static Group getRobo(){
        Vektor v1=new Vektor(5,5,0);
        Vektor v2=new Vektor(35,5,0);
        Vektor v3=new Vektor(35,35,0);
        Vektor v4=new Vektor(5,35,0);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,40);
        Vektor v6=new Vektor(35,5,40);
        Vektor v7=new Vektor(35,35,40);
        Vektor v8=new Vektor(5,35,40);
        Quad q2=new Quad(Color.orange,Color.black,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,40);
        Vektor v10=new Vektor(35,5,40);
        Vektor v11=new Vektor(35,5,0);
        Vektor v12=new Vektor(5,5,0);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,35,40);
        Vektor v14=new Vektor(35,35,40);
        Vektor v15=new Vektor(35,35,0);
        Vektor v16=new Vektor(5,35,0);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,5,40);
        Vektor v18=new Vektor(5,35,40);
        Vektor v19=new Vektor(5,35,0);
        Vektor v20=new Vektor(5,5,0);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(35,5,40);
        Vektor v22=new Vektor(35,35,40);
        Vektor v23=new Vektor(35,35,0);
        Vektor v24=new Vektor(35,5,0);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        Vektor v25=new Vektor(10,10,40);
        Vektor v26=new Vektor(30,10,40);
        Vektor v27=new Vektor(20,30,40);
        Vektor v28=new Vektor(20,30,40);
        Quad q7=new Quad(Color.green,Color.black,v25,v26,v27,v28);
        PaintGroup pg=new PaintGroup();
        q2.setPaintGroup(pg);
        q7.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        g.add(q7);
        return g;
    }
}
class EngineKmoon3D2 extends JPanel{
    Thread t;
    ImageFrameKmoon3D2 imf;
    Image img;
    Graphics h;
    Polygon start;
    Polygon end;
    PaintGroup pgstart;
    PaintGroup pgend;
    String status="astrosolutions.de";
    boolean first=true;
    boolean ison=false;
    Graphics paintg;
    boolean inverse=false;
    private static final long serialVersionUID = -2247835081198967829L;
    public EngineKmoon3D2(){
        imf=new ImageFrameKmoon3D2();
        img=imf.img;
        h=img.getGraphics();
//        t=new Thread(this);
//        t.start();
    }
    public synchronized void setOn(){
        first=false;
        ison=true;
    }
    public synchronized void setOff(){
        ison=false;
    }
    public synchronized void setInverseOn(){
        inverse=true;
    }
    public synchronized void setInverseOff(){
        inverse=false;
    }
    public synchronized void run(){
        boolean running=true;
//        try{
//            while(running){
//                Thread.sleep(100);
//                repaint();
//            }
//        }
//        catch(Exception e){
//        }
    }
    public synchronized void setNotProcessed(){
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg!=null){
                cur.pg.setNotProcessed();
            }
            cur=cur.next;
        }
    }
    public synchronized void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(cur.pg!=null){
                    cur.pg.remove(cur);
                }
                if(fore==null){
                    start=cur.next;
                }
                if(cur.next==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.next=cur.next;
                }
            }
            fore=cur;
            cur=cur.next;
        }
    }
    public synchronized void remove(Group g){
        Polygon cur=g.start;
        while(cur!=null){
            remove(cur);
            cur=cur.grnext;
        }
    }
    public synchronized void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public synchronized void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public synchronized void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public synchronized void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
    public synchronized void getPaintGroups(){
        pgstart=null;
        pgend=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg==null){
                cur.pg=new PaintGroup();
                cur.pg.add(cur);
                cur.pg.setProcessed();
                addPaintGroup(cur.pg);
            }
            else{
                if(!cur.pg.processed){
                    addPaintGroup(cur.pg);
                    cur.pg.setProcessed();
                }
            }
            cur=cur.next;
        }
    }
    public synchronized void addPaintGroup(PaintGroup pg){
        if(pgstart==null){
            pgstart=pg;
            pgend=pg;
        }
        else{
            pgend.next=pg;
            pgend=pgend.next;
        }
    }
    public synchronized void add(Polygon p){
        p.next=null;
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.next=p;
            end=end.next;
        }
    }
    public synchronized void add(Group group){
        Polygon cur=group.start;
        while(cur!=null){
            add(cur);
            cur=cur.grnext;
        }
    }
    public static void sort(PaintGroup[]a,int l,int r){
//Quicksort sortiert PaintGroups nach entf-Werten
        if(l>=r){
            return;
        }
        PaintGroup[]part=new PaintGroup[r-l+1];
        PaintGroup[]partm=new PaintGroup[r-l+1];
        int middle=(l+r)/2;
        double middlevalue=a[middle].entf;
        int i=0;
        int j=r-l;
        int m=0;
        for(int k=l;k<=r;k++){
            if(a[k].entf<middlevalue){
                part[i]=a[k];
                i++;
            }
            else if(a[k].entf>middlevalue){
                part[j]=a[k];
                j--;
            }
            else{
                partm[m]=a[k];
                m++;
            }
        }
        for(int k=0;k<i;k++){
            a[k+l]=part[k];
        }
        for(int k=0;k<m;k++){
            a[i+k+l]=partm[k];
        }
        for(int k=r-l;k>j;k--){
            a[k+l]=part[k];
        }
        sort(a,l,i-1+l);
        sort(a,j+1+l,r);
    }
    public synchronized Vektor getCoord(Vektor v){
        double x=v.xb;
        double y=v.yb;
        double z=v.zb;
        int w=(getSize().width)/2;
        double vx=Math.atan(y/x)/(Math.PI/6)*w;
        double vy=Math.atan(z/x)/(Math.PI/6)*w;
        double vz=x;
        Vektor rvv=new Vektor(vx,vy,vz);
        return rvv;
    }
    public synchronized void paintb(Graphics g){
//        if(first){
//            return;
//        }
    }
    public synchronized void paint(Graphics g){
        if(first){
            return;
        }
        if(!ison){
            if(paintg!=null){
//                paint(paintg);
//                return;
            }
        }
        h.setColor(Color.white);
        h.fillRect(0,0,800,600);
        setNotProcessed();
        getPaintGroups();
        PaintGroup pgcur=pgstart;
        int count=0;
        while(pgcur!=null){
            pgcur.getEntf();
            pgcur=pgcur.next;
            count++;
        }
        pgcur=pgstart;
        PaintGroup[]pgs=new PaintGroup[count];
        for(int i=0;i<count;i++){
            pgs[i]=pgcur;
            pgcur=pgcur.next;
        }
        sort(pgs,0,pgs.length-1);
        int width=getSize().width;
        int height=getSize().height;
        for(int i=pgs.length-1;i>=0;i--){
            Polygon pol=pgs[i].start;
            while(pol!=null){
                Vektor point=pol.start;
                if(pol.kugel){
                    Vektor kv=getCoord(point);
                    if(kv.z>0){
                        double winkel=Math.atan(pol.radius/pgs[i].entf);
                        int len=(int)((winkel/(Math.PI/6))*width/2)*2;
                        h.setColor(pol.col);
                        if(!inverse){
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2-(len/2)-((int)kv.y),len,len);
                        }
                        else{
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2+(len/2)-((int)kv.y),len,len);
                        }
                    }
                }
                else{
                    java.awt.Polygon pogy=new java.awt.Polygon();
                    boolean seen=true;
                    while(point!=null){
                        Vektor veci=getCoord(point);
                        if(veci.z<=0){
                            seen=false;
                        }
                        if(!inverse){
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2-veci.y));
                        }
                        else{
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2+veci.y));
                        }
                        point=point.next;
                    }
                    if(seen){
                        h.setColor(pol.col);
                        h.fillPolygon(pogy);
                        if(pol.col!=pol.rcol){
                            h.setColor(pol.rcol);
                            h.drawPolygon(pogy);
                        }
                    }
                }
                pol=pol.gnext;
            }
        }
        h.setColor(Color.blue);
        h.drawString(status,10,90);
        g.drawImage(img,0,0,this);
        paintg=g;
//        paint(g);
    }
    public synchronized void setStatus(String status){
        this.status=status;
    }
}
class PaintGroup{
    PaintGroup next;
    Polygon start;
    Polygon end;
    boolean processed=false;
    double entf=0;
    public PaintGroup(){
    }
    public void getEntf(){
        entf=entf();
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void reset(){
        start=null;
        end=null;
    }
    public void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(fore==null){
                    start=cur.gnext;
                }
                if(cur.gnext==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.gnext=cur.gnext;
                }
            }
            fore=cur;
            cur=cur.gnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.gnext=p;
            end=end.gnext;
        }
    }
    public double entf(){
        int count=0;
        Polygon cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            Vektor cur2=cur.start;
            while(cur2!=null){
                sum.transform(cur2.getXb(),cur2.getYb(),cur2.getZb());
                cur2=cur2.next;
                count++;
            }
            cur=cur.gnext;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
}
class Group{
    Polygon start;
    Polygon end;
    public Group cloneo(){
        Group group=new Group();
        Polygon cur=start;
        while(cur!=null){
            group.add(cur.cloneo());
            cur=cur.grnext;
        }
        return group;
    }
    public void change(Color a,Color b){
        Polygon cur=start;
        while(cur!=null){
            cur.change(a,b);
            cur=cur.grnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.grnext=p;
            end=end.grnext;
        }
    }
    public void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.grnext;
        }
    }
    public void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.grnext;
        }
    }
    public void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.grnext;
        }
    }
    public void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.grnext;
        }
    }
}
class Kugel extends Polygon{
    public Kugel(Color col,Color rcol,Vektor v,double radius){
        super(col,rcol);
        add(v);
        this.radius=radius;
        this.kugel=true;
    }
    public Vektor getCenter(){
        return start;
    }
}
class Quad extends Polygon{
    public Quad(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3,Vektor v4){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
        add(v4);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
    public Vektor getV4(){
        return start.next.next.next;
    }
}
class Triangle extends Polygon{
    public Triangle(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
}
class Polygon{
    Polygon next;
    Polygon gnext;
    Polygon grnext;
    PaintGroup pg;
    Vektor start;
    Vektor end;
    Color col;
    Color rcol;
    boolean kugel=false;
    double radius=0;
    boolean processed=false;
    double entf=0;
    public Polygon(Color col,Color rcol){
        this.col=col;
        this.rcol=rcol;
    }
    public void change(Color a,Color b){
        if(col.equals(a)){
            col=b;
        }
    }
    public Polygon cloneo(){
        Polygon ret=new Polygon(col,rcol);
        ret.kugel=kugel;
        ret.radius=radius;
        ret.processed=processed;
        ret.entf=entf;
        Vektor cur=start;
        while(cur!=null){
            ret.add(cur.cloneo());
            cur=cur.next;
        }
        return ret;
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void setPaintGroup(PaintGroup pg){
        this.pg=pg;
        pg.add(this);
    }
    public void add(Vektor v){
        if(start==null){
            start=v;
            end=v;
        }
        else{
            end.next=v;
            end=end.next;
        }
    }
    public void move(){
        Vektor cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public void rotUp(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public void rotLeft(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public double entf(){
        int count=0;
        Vektor cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            sum.transform(cur.getX(),cur.getY(),cur.getZ());
            cur=cur.next;
            count++;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
    public void transform(double a,double b,double c){
        Vektor cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
}
class ImageFrameKmoon3D2 extends JFrame{
    Image img;
    private static final long serialVersionUID = -2175161156406016058L;
    public ImageFrameKmoon3D2(){
        pack();
        img=createImage(800,600);
    }
}
class Vektor{
    double x,y,z;
    double xb,yb,zb;
    double xtra;
    Vektor next;
    public Vektor(double x,double y,double z){
        this.x=x;
        this.y=y;
        this.z=z;
    }
    public void print(){
        System.out.println("x: "+x+" y: "+y+" z: "+z);
    }
    public double getX(){
        return x;
    }
    public double getY(){
        return y;
    }
    public double getZ(){
        return z;
    }
    public double getXb(){
        return xb;
    }
    public double getYb(){
        return yb;
    }
    public double getZb(){
        return zb;
    }
    public double getXtra(){
        return xtra;
    }
    public Vektor cloneo(){
        Vektor cl=new Vektor(x,y,z);
        cl.xb=xb;
        cl.yb=yb;
        cl.zb=zb;
        cl.xtra=xtra;
        return cl;
    }
    public void move(){
        xb=x;
        yb=y;
        zb=z;
    }
    public void transform(double a,double b,double c){
        x+=a;
        y+=b;
        z+=c;
    }
    public void setCoord(int coord,double a){
        if(coord==1)x=a;
        else if(coord==2)y=a;
        else if(coord==2)z=a;
    }
    public void changeCoord(int coord1,int coord2){
        double temp=0;
        if((coord1==1&&coord2==2)||(coord1==2&&coord2==1)){
            temp=x;
            x=y;
            y=temp;
        }
        if((coord1==1&&coord2==3)||(coord1==3&&coord2==1)){
            temp=x;
            x=z;
            z=temp;
        }
        if((coord1==2&&coord2==3)||(coord1==3&&coord2==1)){
            temp=y;
            y=z;
            z=temp;
        }
    }
    public double entf(){
        return Math.sqrt(x*x+y*y+z*z);
    }
    public void rotLeft(double w){
        double win=0;
        if(x==0){
            if(y>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(y/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+y*y);
        win+=w;
        x=Math.cos(win)*len;
        y=Math.sin(win)*len;
    }
    public void rotUp(double w){
        double win=0;
        if(x==0){
            if(z>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(z/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+z*z);
        win+=w;
        x=Math.cos(win)*len;
        z=Math.sin(win)*len;
    }
}
class KeyboardMapperAppletSwing extends JPanel implements ActionListener,KeyListener,MouseListener{
    JLabel info;
    ListBox l;
    JButton remove;
    JButton addspecial;
    JButton apply;
    JButton cancel;
    JButton dontapply;
    boolean cancelb=false;
    boolean applyb=false;
    boolean closed=false;
    int kstatus=0;
    int aliasx=0;
    KeyMapperTable kmt;
    JApplet applet;
    int[]alias=new int[0];
    int[]key=new int[0];
    boolean[]special=new boolean[0];
    private static final long serialVersionUID = 5772434866526097156L;
    public KeyboardMapperAppletSwing(JApplet applet){
        setSize(400,400);
        setLayout(null);
        this.applet=applet;
        info=new JLabel("");
        l=new ListBox();
        remove=new JButton("remove");
        addspecial=new JButton("add special key");
        apply=new JButton("apply");
        cancel=new JButton("cancel");
        dontapply=new JButton("don't apply");
        add(info);
        add(l);
        add(remove);
        add(addspecial);
        add(apply);
        add(cancel);
        add(dontapply);
        info.setBounds(10,10,380,27);
        l.setBounds(10,40,380,170);
        remove.setBounds(10,250,80,27);
        addspecial.setBounds(10,280,380,27);
        apply.setBounds(10,310,80,27);
        cancel.setBounds(210,310,80,27);
        dontapply.setBounds(10,340,160,27);
        kmt=new KeyMapperTable();
        loadfirst();
        savekmt();
        remove.addActionListener(this);
        addspecial.addActionListener(this);
        apply.addActionListener(this);
        cancel.addActionListener(this);
        dontapply.addActionListener(this);
        addKeyListener(this);
        addMouseListener(this);
        info.setOpaque(true);
        info.setBackground(Color.white);
    }
    public InputStream getInputStream(String filename){
        try{
            InputStream is=applet.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
        }
        return null;
    }
    public synchronized void mousePressed(MouseEvent me) {
        requestFocus();
        l.click(me.getX()-10,me.getY()-40);
        l.repaint();
    }
    public synchronized void mouseReleased(MouseEvent e) {
    }
    public synchronized void mouseExited(MouseEvent e) {
    }
    public synchronized void mouseEntered(MouseEvent e) {
    }
    public synchronized void mouseClicked(MouseEvent e) {
    }
    public int getKeyCode(int a){
        int n=alias.length;
        for(int i=0;i<n;i++){
            if(alias[i]==a){
                return key[i];
            }
        }
        return a;
    }
    public void savekmt(){
        alias=kmt.alias;
        key=kmt.key;
        special=kmt.special;
    }
    public void restorekmt(){
        kmt.alias=alias;
        kmt.key=key;
        kmt.special=special;
        l.reset();
        int n=key.length;
        for(int i=0;i<n;i++){
            l.addElement("special key "+alias[i]+" alias for "+key[i]);
        }
        l.repaint();
    }
    public void loadfirst(){
        try{
            FileInputStream fis=new FileInputStream("keymapforus.ini");
            fis.close();
            load("keymapforus.ini");
            info.setText("keymapforus.ini loaded and not applied");
        }
        catch(Exception e){
        }
    }
    public void load(String filename){
        try{
            FileInputStream fis=new FileInputStream(filename);
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            String inp=null;
            while((inp=dis.readLine())!=null){
                String inp2=dis.readLine();
                String inp3=dis.readLine();
                kmt.addspecial(inp,inp2);
            }
            dis.close();
            fis.close();
            alias=kmt.alias;
            key=kmt.key;
            special=kmt.special;
            int n=alias.length;
            for(int i=0;i<n;i++){
                l.addElement("special key "+alias[i]+" alias for "+key[i]);
            }
            l.repaint();
        }
        catch(Exception e){
            info.setText("File not found: "+filename);
        }
    }
    public void keyTyped(KeyEvent e){
    }
    public synchronized void keyPressed(KeyEvent e){
        requestFocus();
        int ekey=e.getKeyCode();
        if(kstatus==1){
            aliasx=ekey;
            kstatus=2;
            info.setText("type key");
        }
        else if(kstatus==2){
            int keyx=ekey;
            kstatus=0;
            info.setText("special key added");
            info.setBackground(Color.white);
            kmt.addspecial(""+aliasx,""+keyx);
            l.addElement("special key "+aliasx+" alias for "+keyx);
            l.repaint();
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public void actionPerformed(ActionEvent evt){
        if(evt.getSource()==remove){
            int ind=l.getSelectedIndex();
            if(ind!=-1){
                l.removeElementAt(ind);
                kmt.remove(ind);
                l.repaint();
            }
        }
        if(evt.getSource()==addspecial){
            info.setText("type alias");
            kstatus=1;
            info.setBackground(Color.yellow);
            requestFocus();
        }
        if(evt.getSource()==apply){
            alias=kmt.alias;
            key=kmt.key;
            special=kmt.special;
            applyb=true;
            closed=true;
            setVisible(false);
        }
        if(evt.getSource()==cancel){
            restorekmt();
            cancelb=true;
            closed=true;
            setVisible(false);
        }
        if(evt.getSource()==dontapply){
            applyb=false;
            info.setText("KeyboardMapper isn't applied");
        }
    }
}
class KeyMapperTable{
    int[]alias=new int[0];
    int[]key=new int[0];
    boolean[]special=new boolean[0];
    public KeyMapperTable(){
    }
    public void reset(){
        alias=new int[0];
        key=new int[0];
        special=new boolean[0];
    }
    public void addspecial(String a,String b){
        int n=alias.length;
        int[]aliasb=new int[n+1];
        int[]keyb=new int[n+1];
        boolean[]specialb=new boolean[n+1];
        for(int i=0;i<n;i++){
            aliasb[i]=alias[i];
            keyb[i]=key[i];
            specialb[i]=special[i];
        }
        try{
            aliasb[n]=new Integer(a).intValue();
            keyb[n]=new Integer(b).intValue();
        }
        catch(Exception exc){
        }
        specialb[n]=true;
        alias=aliasb;
        key=keyb;
        special=specialb;
    }
    public void remove(int ind){
        int n=alias.length;
        if(n>0){
            int[]aliasb=new int[n-1];
            int[]keyb=new int[n-1];
            boolean[]specialb=new boolean[n-1];
            int ib=0;
            for(int i=0;i<n;i++){
                if(i==ind){
                }
                else{
                    aliasb[ib]=alias[i];
                    keyb[ib]=key[i];
                    specialb[ib]=special[i];
                    ib=ib+1;
                }
            }
            alias=aliasb;
            key=keyb;
            special=specialb;
        }
    }
}
class ListBox extends JPanel{
    String[]thestrings=new String[0];
    GetImgKeyboardMapper gikm;
    Image img;
    int uppest=0;
    int n=0;
    int ind=-1;
    private static final long serialVersionUID = -457533304480165971L;
    public ListBox(){
        setLayout(null);
        gikm=new GetImgKeyboardMapper();
        img=gikm.img;
        repaint();
    }
    public synchronized void reset(){
        thestrings=new String[0];
        n=0;
        uppest=0;
        ind=-1;
    }
    public synchronized void setListData(String[]str){
        thestrings=str;
        n=thestrings.length;
    }
    public synchronized void addElement(String s){
        String[]thestrings2=new String[n+1];
        for(int i=0;i<n;i++){
            thestrings2[i]=thestrings[i];
        }
        thestrings2[n]=s;
        n=n+1;
        thestrings=thestrings2;
        uppest=n-8;
        if(uppest<0){
            uppest=0;
        }
    }
    public synchronized void removeElementAt(int ind2){
        int n=thestrings.length;
        if(n>0){
            if(ind==ind2){
                ind=-1;
            }
            else if(ind>ind2){
                ind=ind-1;
            }
            String[]thestrings2=new String[n-1];
            int ib=0;
            for(int i=0;i<n;i++){
                if(i==ind2){
                }
                else{
                    thestrings2[ib]=thestrings[i];
                    ib=ib+1;
                }
            }
            thestrings=thestrings2;
            this.n=n-1;
            if(uppest+8>=n){
                uppest=uppest-1;
                if(uppest<0){
                    uppest=0;
                }
            }
        }
    }
    public synchronized int getSelectedIndex(){
        return ind;
    }
    public synchronized void click(int x,int y){
        if(x>=10&&x<370&&y>=5&&y<5+16){
            uppest=uppest-1;
            if(uppest<0){
                uppest=0;
            }
        }
        if(x>=10&&x<370&&y>=5+9*16&&y<5+9*16+16){
            uppest=uppest+1;
            if(uppest+8>n){
                uppest=uppest-1;
            }
        }
        if(x>=10&&x<370&&y>=5+16&&y<5+8*16+16){
            int ind2=(y-5-16)/16+uppest;
            if(ind2>=0&&ind2<n){
                ind=ind2;
            }
        }
    }
    public synchronized void paint(Graphics g){
        Graphics h=img.getGraphics();
        h.setColor(Color.white);
        h.fillRect(0,0,380,170);
        h.setColor(Color.black);
        for(int i=0;i<10;i++){
            h.setColor(Color.black);
            if(ind==uppest+i-1&&ind!=-1&&i!=0&&i!=9){
                h.setColor(Color.green);
            }
            h.drawRect(10,5+i*16,360,15);
        }
        h.setColor(Color.black);
        if(uppest==0){
            h.setColor(Color.red);
        }
        h.drawString("UP",12,5+14);
        h.setColor(Color.black);
        if(uppest+8>=n){
            h.setColor(Color.red);
        }
        h.drawString("DOWN",12,5+9*16+14);
        h.setColor(Color.black);
        for(int i=0;i<8;i++){
            h.setColor(Color.black);
            if(ind==uppest+i&&ind!=-1){
                h.setColor(Color.green);
            }
            int theindex=uppest+i;
            if(theindex<n){
                h.drawString(thestrings[theindex],12,5+16+i*16+14);
            }
        }
        g.drawImage(img,0,0,this);
    }
}
class GetImgKeyboardMapper extends JFrame{
    Image img;
    private static final long serialVersionUID = -8478639040178665797L;
    public GetImgKeyboardMapper(){
        pack();
        img=createImage(380,170);
    }
}
